#include <fstream.h>
#include <iostream.h>
#include <math.h>


int quer(int k) {

  int q=0;
  
  while (k) {
    q+=k%10;
    k/=10;
  }
  return q;
}

int smith(int k) {

  int q;
  int q2;
  int kk;
  k++;
  if (k<4) k=4;
  while (1) {
    q=0;
    q2=quer(k);
    //cout << "smith " << k << " quer " << q2;
    kk=k;
    for (int i=2;i<=sqrt(kk); i++) {
      while (kk % i == 0) {
	kk/=i;
	//cout << "  " << i << " q " << quer(i);
	q+=quer(i);
      }
      if (q>q2) break;
    }
    if (kk != k) {
      if (kk!=1) q+=quer(kk);
      //cout << "q " << q << "   q2 " << q2 << endl;
      if (q == q2) return k;
    }
    k++;
  }
  return 0;
}


int main() {
  int n;

  ifstream IN("smith.in",ios::in);

  while (1) {
    IN >> n;

    if (n ==0) break;
    //cout << "checkin " << n << endl;
    int s = smith(n);
    cout << s << endl;
    
  }

  IN.close();
  return 0;
}
