#include <fstream.h>
#include <iostream.h>
#include <string.h>




int winner[21];
int allowed[21];



void add(int what, int * al) {

  for (int i=what;i<21;i+=what) {
    al[i]=0;
  }
  for (int i=2;i+what<21;i++) {
    if (!al[i]) {
      al[i+what]=0;
    }
  }
}

int alleft(int *al) {

  for (int i=2; i<21; i++) {

    if (al[i]) return 1;
    
  }

  return 0;
}

void cpy(int *dst, int *src) {
  memcpy(dst,src,21*sizeof(int));
}

int wins(int * al, int first, int rec) {

  int win=0;
  int lal[21];
  if (rec>22) {
    return 0;
  }

  for (int i=2; i<21; i++) {
    if (i%18 != 0) {
      if (al[i]) {
	cpy(lal,al);
	add(i,lal);
	if (!alleft(lal)) {
	  if (first) {
	    win=1;
	    winner[i]=1;
	  } else {
	    return 1;
	  }
	} else {
	  if (!wins(lal,0,rec+1)) {
	    if (first) {
	      win=1;
	      winner[i]=1;
	    } else {
	      return 1;
	    }
	    
	  }
	}
      }
    }
  }
  if (win) return 1;
  return 0;
}


int main() {

  ifstream IN("numbergame.in",ios::in);
  int test=0;
  while (1) {
    test++;
    for (int i=0;i<21;i++) {
      winner[i]=0;
      allowed[i]=0;
    }
    int nb;
    IN >> nb;
    if (nb == 0) break;
    for (int k=0;k<nb;k++) {

      int a;
      IN >> a;
      allowed[a]=1;

    }

    cout << "Test Case #" << test << endl;
    if (wins(allowed,1,0)) {

      cout << "The winning moves are:";
      for (int i=0; i<20; i++) {

	if (winner[i]) {
	  cout << " " << i;
	}

      }
      cout << endl << endl;
    } else {
      cout << "There's no winning move.\n\n";
    }

  }

  IN.close();
}
