#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

struct _x
{
  struct {
    int stime,etime;
  } rts[100];
  int routeNo;
} routes[100][100];
int cities;
char names[100][300];
int nameNo;


int depSta,earliestDTime,bestDTime;

int doFrom(int staNo, int time)
{
  int res=0;
  if (time<earliestDTime) return 0;
  else if (staNo==depSta){
    if (bestDTime<=time){
      bestDTime=time;
      return 1;
    }
    else return 0;
  }
  else {
    int i,j;
    for (i=0;i<cities;i++){
      for (j=0;j<routes[i][staNo].routeNo;j++){
	if (routes[i][staNo].rts[j].etime<=time){
	  if (doFrom(i,routes[i][staNo].rts[j].stime)){
	    res=1;
	  }
	}
      }
    }
  }
  return res;
}

int getSta(char *name)
{
  int i=0;
  for (i=0;i<cities;i++){
    if (!strcmp(name, names[i])) return i;
  }
  return -1;
}

FILE *in;

int getTime()
{
  int res,tmp;
  fscanf(in," %d ",&tmp);
  res=tmp%10;
  res+=tmp/10;
  return res;
  
}


int main()
{
  int scene=1;
  int i,j,tmp,routes,lastSta;
  char buf[300];
  
  
  in=fopen("railroad.in","r");
  
  while(1){
    fscanf(in," %d ", &cities);
    if (cities==0) break;
    for (i=0;i<cities;i++){
      fscanf(in, " %s ", names[i]);
    }
    
    fscanf(in," %d ", &routes);
    for (i=0;i<routes;i++){
      int stops,lastTime;
      char *lastName;
      
      fscanf(in," %d ", &stops);
      stops--;
      lastTime=getTime();
      fscanf(in, " %s ", buf);
      lastName=strdup(buf);
      for (j=0;j<stops;j++){
	int time;
	char *newName;
	
	time=getTime();
	fscanf(in, " %s ", buf);
	newName=strdup(buf);
	routes[getSta(lastName)][getSta(newName)]
	  .rts[routes[getSta(lastName)][getSta(newName)].routeNo].stime = lastTime;
	routes[getSta(lastName)][getSta(newName)]
	  .rts[routes[getSta(lastName)][getSta(newName)].routeNo].etime = time;
	routes[getSta(lastName)][getSta(newName)].routeNo++;
	lastTime=time;
	lastName=newName;
      }
    }

    
    earliestDTime=getTime();

    fscanf(in," %s ",&buf);
    depSta=getSta(buf);
    fscanf(in," %s ",&buf);
    lastSta=getSta(buf);
    bestATime=-1;
    bestDTime=earliestDTime;
    for (i=0;i<cities;i++){
      for (j=0;j<routes[i][staNo].routeNo;j++){
	if ((bestATime==-1)||
	    (bestATime>=routes[i][lastSta].rts[j].etime)){
	  int oldBestDTime;
	  oldBestDTime=bestDTime;
	  if (bestATime>routes[i][lastSta].rts[j].etime) bestDTime=earliestDTime;
	  if (doFrom(i, routes[i][lastSta].rts[j].stime)) bestATime = routes[i][lastSta].rts[j].etime;
	  else bestDTime = oldBestDTime;
	}
      }
    }
    printf("Scenario #%d\n",scene++);
    if (bestATime==-1) printf("No connection\n");
    else {
      
    }
    

  }
  

  return 0;
}
